﻿using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Hosting;

namespace Lesson49.Controllers
{
    public class HomeController : Controller
    {
        private readonly IHostEnvironment _appEnvironment;

        public HomeController(IHostEnvironment appEnvironment)
        {
            _appEnvironment = appEnvironment;
        }

        public IActionResult Index(int? id)
        {
            return Json(id);
        }
        

        public IActionResult DownloadFile()
        {
            string filePath = Path.Combine("~\\Files", "book.txt");
            return File(filePath, "application/pdf", "newBook.txt");
        }
        
        public FileResult GetFileStream()
        {
            string path = Path.Combine(_appEnvironment.ContentRootPath, "Files/book.pdf");
            FileStream stream = new FileStream(path, FileMode.Open);
            string fileType = "application/pdf";
            string fileName = "book.txt";
            return File(stream, fileType, fileName);
        }

        

        [NonAction]
        public bool GetBool()
        {
            return true;
        }

        public IActionResult GetSum(int num1, int num2)
        {
            return Json(num1+num2);
        }
        
        
        
    }
}