﻿using System.IO;
using System.Linq;
using Lesson49.Models;
using Lesson49.Models.Data;
using Microsoft.AspNetCore.Mvc;
using PdfSharpCore.Drawing;
using PdfSharpCore.Drawing.Layout;
using PdfSharpCore.Pdf;


namespace Lesson49.Controllers
{
    public class UsersController : Controller
    {
        private readonly MobileContext _db;

        public UsersController(MobileContext db)
        {
            _db = db;
        }

        // GET
        public IActionResult Index()
        {
            return View(_db.Users.ToList());
        }

        public IActionResult Create()
        {
            return View();
        }
        
        [HttpPost]
        public IActionResult Create(User user)
        {
            _db.Users.Add(user);
            _db.SaveChanges();
            return RedirectToAction("Index");
        }

        // public IActionResult GetPdf(int id)
        // {
        //     User user = _db.Users.FirstOrDefault(u => u.Id == id);
        //     PdfDocument document = new PdfDocument();
        //     PdfPage page = document.Pages.Add();
        //     PdfGraphics graphics = page.Graphics;
        //     PdfFont font = new PdfStandardFont(PdfFontFamily.Helvetica, 20);
        //     graphics.DrawString(user.ToString(), font, PdfBrushes.Black, new PointF(0, 0));
        //     MemoryStream stream = new MemoryStream();
        //     document.Save(stream);
        //     stream.Position = 0;
        //     FileStreamResult fileStreamResult = new FileStreamResult(stream, "application/pdf");
        //     fileStreamResult.FileDownloadName = "MyFirstPDF.pdf";
        //     return fileStreamResult;
        //
        // }
        
        public IActionResult GetPdf(int id)
        {
            User user = _db.Users.FirstOrDefault(u => u.Id == id);
            PdfDocument document = new PdfDocument();
            document.Info.Title = "My second Pdf";
            PdfPage page = document.AddPage();
            XGraphics gfx = XGraphics.FromPdfPage(page);
            XFont font = new XFont("Verdana", 20, XFontStyle.BoldItalic);
            XTextFormatter formatter = new XTextFormatter(gfx);
            XRect rect = new XRect(10, 10, 540, 700);
            gfx.DrawRectangle(XBrushes.Aquamarine, rect);
            formatter.DrawString(user.ToString(), font, XBrushes.Black,
                rect, XStringFormats.TopLeft);
            MemoryStream stream = new MemoryStream();
            document.Save(stream);
            stream.Position = 0;
            FileStreamResult fileStreamResult = new FileStreamResult(stream, "application/pdf");
            fileStreamResult.FileDownloadName = $"{user.Name}.pdf";
            return fileStreamResult;

        }
    }
}